<template>
    <div
        class="mobile-menu md:hidden"
        :class="{
            'mobile-menu--active': menuOn,
        }"
    >
        <div class="mobile-menu-bar">
            <a
                class="flex mr-auto"
                @click="$router.push({name: 'admin.home'})"
            >
                <img
                    class="w-6"
                    :src="'/img/logo-light.png'"
                >
            </a>
            <a
                href="javascript:"
                class="mobile-menu-toggler"
                @click="toggleMenu"
            >
                <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="lucide w-8 h-8 text-white transform -rotate-90"><line x1="18" y1="20" x2="18" y2="10"></line><line x1="12" y1="20" x2="12" y2="4"></line><line x1="6" y1="20" x2="6" y2="14"></line></svg>
            </a>
        </div>
        <a
            v-if="menuOn"
            href="javascript:"
            class="mobile-menu-toggler fixed top-2 right-2 z-50"
            @click="toggleMenu"
        >
            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="lucide w-8 h-8 text-white transform -rotate-90"><circle cx="12" cy="12" r="10"></circle><line x1="15" y1="9" x2="9" y2="15"></line><line x1="9" y1="9" x2="15" y2="15"></line></svg>
        </a>
        <div class="scrollable overflow-y-scroll">
            <div
                class="mobile-menu-bar-content"
            >
                <ul class="scrollable__content py-2">
                    <li
                        v-for="(menu, key) in computedSideMenu"
                        :key="`menu-${key}`"
                    >
                        <a
                            href="javascript:"
                            class="menu"
                            :class="{
                                'menu--active menu--open': menu.active && menu.children,
                                'menu--active': menu.active && !menu.children,
                            }"
                            @click="tryNavigate(menu, key)"
                        >
                            <div class="menu__icon">
                                <template
                                    v-if="menu.icon === 'home'"
                                >
                                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="lucide"><path d="M3 9l9-7 9 7v11a2 2 0 01-2 2H5a2 2 0 01-2-2z"></path><polyline points="9 22 9 12 15 12 15 22"></polyline></svg>
                                </template>
                                <template
                                    v-else
                                >
                                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="lucide"><rect x="3" y="3" width="18" height="18" rx="2" ry="2"></rect><line x1="9" y1="3" x2="9" y2="21"></line></svg>
                                </template>
                            </div>
                            <div class="menu__title">
                                {{ $t(menu.name) }}
                                <div
                                    v-if="menu.children"
                                    class="menu__sub-icon"
                                    :class="{
                                        'transform rotate-180': menu.active
                                    }"
                                >
                                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="lucide"><polyline points="6 9 12 15 18 9"></polyline></svg>
                                </div>
                            </div>
                        </a>
                        <ul
                            v-if="menu.active && menu.children"
                        >
                            <li
                                v-for="(child, ckey) in menu.children"
                                :key="`menu-${key}-child-${ckey}`"
                            >
                                <a
                                    href="javascript:"
                                    class="menu"
                                    :class="{
                                        'menu--active': child.route === $route.name
                                    }"
                                    @click="tryNavigate(child, key)"
                                >
                                    <div class="menu__icon">
                                        <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="lucide"><polyline points="22 12 18 12 15 21 9 3 6 12 2 12"></polyline></svg>
                                    </div>
                                    <div class="menu__title relative">
                                        {{ $t(child.name) }}
                                        <template
                                            v-if="child.notification && typeof $notifications[child.notification] !== 'undefined' && $notifications[child.notification] > 0"
                                        >
                                            <div
                                                class="absolute inset-y-0 right-2"
                                            >
                                                <span
                                                    class="bg-red-500 rounded-full text-xs w-6 h-6 text-center text-white self-center align-middle flex justify-center items-center"
                                                >
                                                    {{ $notifications[child.notification] }}
                                                </span>
                                            </div>
                                        </template>
                                    </div>
                                </a>
                            </li>
                        </ul>
                    </li>
                </ul>
            </div>
        </div>
    </div>
</template>

<script setup>
import {ref, computed, onMounted} from "vue";
import sideMenu from "~/side-menu.js";
import {useRoute, useRouter} from "vue-router";
import {useAdminStore} from "~/stores/admin.js";

const $router = useRouter();
const $route = useRoute();
const $adminStore = useAdminStore();
const $admin = computed(() => {
    return $adminStore.account;
});
const $notifications = computed(() => {
    return $adminStore.notifications;
});
const isSuperAdmin = computed(() => {
    if (!$admin.value) return false;
    return String($admin.value.type) === String(1) || String($admin.value.type) === String(2);
});
const isDeveloper = computed(() => {
    if (!$admin.value) return false;
    return String($admin.value.type) === String(2);
});
const permissions = computed(() => {
    return $adminStore.permissions;
});

const menuOn = ref(false);

const toggleMenu = () => {
    menuOn.value = !menuOn.value;
};

const activeKey = ref(null);

const computedSideMenu = computed(() => {
    let m = [];
    sideMenu.forEach((row, key) => {
        //Single level
        if (typeof row.children === 'undefined') {
            let can = false;
            if (row.permissions) {
                if (isSuperAdmin.value || isDeveloper.value) {
                    can = true;
                }

                if (!can) {
                    row.permissions.forEach(p => {
                        if (permissions.value.includes(p)) can = true;
                    });
                }
            } else {
                can = true;
            }

            if (can) {
                m.push({
                    ...row,
                    active: activeKey.value === key
                });
            }
        } else {
            let child = [];
            row.children.forEach(sub => {
                let can = false;
                if (sub.permissions) {
                    if (isSuperAdmin.value || isDeveloper.value) {
                        can = true;
                    }

                    if (!can) {
                        sub.permissions.forEach(p => {
                            if (permissions.value.includes(p)) can = true;
                        });
                    }
                } else {
                    can = true;
                }

                if (can) {
                    child.push(sub);
                }
            });

            if (child) {
                m.push({
                    ...row,
                    children: child,
                    active: activeKey.value === key || (child.find(r => $route.name === r.name))
                });
            }
        }
    });
    return m;
});

const tryNavigate = async (nav, k) => {
    if (nav.route) {
        menuOn.value = false;
        await $router.push({name: nav.route});
    }

    activeKey.value = k;
};

onMounted(() => {
    let k = null;
    computedSideMenu.value.forEach((row, key) => {
        if (row.children) {
            row.children.forEach((sub, skey) => {
                if (sub.route === $route.name) {
                    k = key;
                }
            });
        } else {
            if (row.route === $route.name) {
                k = key;
            }
        }
    });

    activeKey.value = k;
});
</script>
